{- This is the Main module which is used by the buddha
   declarative debugger for Haskell. Don't modify this file unless
   you are sure about what you are doing 

   Author: Bernie Pope
   buddha website: www.cs.mu.oz.au/~bjpop/buddha
-}

module Main where

import DD (dd) 
import Buddha (run)
import qualified Main_B (main)
import IOPrims_B (runIO)
import Prelude
import Posix 
import Control.Concurrent 
import Control.Exception 

main :: Prelude.IO ()
main = do catchCtrlC 
          let debugee = do io <- Main_B.main
                           IOPrims_B.runIO io
          case run 0 debugee of
             (Left e,   _line, trees) -> dd (Just e) trees
             (Right (), _line, trees) -> dd Nothing  trees 

catchCtrlC :: Prelude.IO Handler 
catchCtrlC 
   = do main_thread <- myThreadId
        installHandler sigINT (Catch (hupHandler main_thread)) Nothing
        where
        hupHandler :: ThreadId -> IO ()
        hupHandler main_thread
           = throwTo main_thread (ErrorCall "Interrupt Signal")
